#include "ti83plusklein.inc"
#define B_CALL(xxxx) rst 28h \ .dw xxxx
#define B_JUMP(xxxx) call 50h \ .dw xxxx

     .org 9D95h
     
     ld   b,0
     ld   hl,1
Delay:
     HALT
     DJNZ Delay
     
     call CLL_DefineLink
     
     jr   nc,DispHL
     INC  l
DispHL:
     B_CALL(_disphl)
     RET
     
     
     
     
     
     
     
;    Input:    Output:
;A   -         0
;B   -         -
;C   -         -
;D   -         -
;E   -         -
;F   -         %01*1*10? (Bit 0 Holds The Calc's Identity, 0=Calc1 1=Calc2)
;H   -         -
;L   -         -
;32 Bytes
;
CLL_DefineLink
     DI                       ;Disable Interrupts
     XOR  a                   ;Both High
     OUT  (0),a               ;Write
     IN   a,(0)               ;Read
     AND  2                   ;Ring High?
     jr   z,Calc2             ;If not -> Calc2
     
Calc1:                        ;(Tip High, Ring Low)
     OUT  (0),a               ;Write
     
Calc1Loop:
     IN   a,(0)               ;Read
     AND  1                   ;Tip High?
     jr   nz,Calc1Loop        ;If so -> Calc1Loop
     
Return:                       ;(Both High)
     OUT  (0),a               ;Write
     EI                       ;Enable Interrupts
     RET                      ;Return
     
Calc2:
     INC  a                   ;Tip Low, Ring High
     OUT  (0),a               ;Write
     jr   $+2                 ;3 NOPS, 2 BYTES
     XOR  a                   ;Both High
     SCF                      ;Set Carry Flag
     jr   Return              ;-> Return
     
     .end
END
